import * as React from 'react';
interface IData {
    isHoliday?: boolean;
    price?: number;
    rent: string[] | string[][];
    revert: string[] | string[][];
    disabled?: 'ALL' | 'PART' | 'DISABLED';
    badge?: string;
}
interface IProps {
    readonly?: boolean;
    title?: string;
    onClose: () => void;
    disabledBefore?: Date;
    monthRange: [Date, Date];
    chooseRange?: [Date, Date];
    onSubmit: (start: Date, end: Date) => void;
    onDayClick?: (day: Date, type: 'rent' | 'revert') => any;
    lock?: 'start' | 'end';
    localCheckTimeRange?: boolean;
    data?: {
        [time: number]: IData;
    };
    minHours?: number;
    maxHours?: number;
    extend?: 'before' | 'after' | 'both';
}
interface IState {
    chooseRange: [Date | null, Date | null];
    preChooseRange: [Date | null, Date | null];
    timePickerVisible: boolean;
    timePickerTimes: [Date | null, Date | null];
    timePickerTips: Record<string, string>;
    preTimePickerTimes: [Date | null, Date | null];
    timePickerData: {
        day: Date;
        times?: string[] | string[][];
    };
    chooseType: string;
}
declare class Controller extends React.PureComponent<IProps, IState> {
    timePickerRef: React.RefObject<any>;
    constructor(props: IProps);
    componentDidMount(): void;
    replaceRange: (range: [Date, Date]) => void;
    protected getMonthList(): Date[];
    protected isBtweenChooseRange(date: Date): boolean;
    protected isBtweenRange(date: Date, range: [Date | null, Date | null]): boolean;
    protected onDayClick(day: Date, data: IData): Promise<void>;
    protected clearChooseRange: () => void;
    protected timePickerCancel: () => void;
    protected timePickerNext: () => Promise<void>;
    protected onTimeChange: () => void;
    protected onSubmit: () => void;
    private isZeroTime;
    private checkTimeRangeCanUsed;
}
export default Controller;
