var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import * as React from 'react';
import { dateFormat, offsetHours, stringToDate } from '../__utils/transfer';
import Alert from '../alert';
import Loading from '../loading';
import Toast from '../toast';
var Controller = /** @class */ (function (_super) {
    __extends(Controller, _super);
    function Controller(props) {
        var _this = _super.call(this, props) || this;
        _this.timePickerRef = React.createRef();
        // 公开方法，替换范围
        _this.replaceRange = function (range) {
            var rentDay = stringToDate(dateFormat(range[0], 'yyyyMMdd'));
            var revertDay = stringToDate(dateFormat(range[1], 'yyyyMMdd'));
            _this.setState({
                chooseRange: [rentDay, revertDay],
                preChooseRange: __spreadArrays(_this.state.chooseRange),
                timePickerTimes: range,
                preTimePickerTimes: __spreadArrays(_this.state.timePickerTimes),
                timePickerVisible: false,
            });
        };
        // 清空选择的日期
        _this.clearChooseRange = function () {
            if (_this.props.lock) {
                Toast('当前租期不可清空');
                return;
            }
            _this.setState({
                chooseRange: [null, null],
                preChooseRange: [null, null],
                timePickerTimes: [null, null],
                preTimePickerTimes: [null, null],
            });
        };
        // 取消日期选择
        _this.timePickerCancel = function () {
            _this.setState({
                chooseRange: __spreadArrays(_this.state.preChooseRange),
                timePickerTimes: __spreadArrays(_this.state.preTimePickerTimes),
                timePickerVisible: false,
            });
        };
        // 日期选择下一步
        _this.timePickerNext = function () { return __awaiter(_this, void 0, void 0, function () {
            var max, min, times, offset, tips, resetTime;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.timePickerRef.current) {
                            return [2 /*return*/];
                        }
                        max = this.props.maxHours || 99999;
                        min = this.props.minHours || 0;
                        times = [
                            this.state.timePickerTimes[0],
                            this.state.timePickerTimes[1],
                        ];
                        if (this.state.chooseType === 'rent') {
                            times[0] = this.timePickerRef.current.getTime();
                            if (this.props.extend !== 'before' && this.props.extend !== 'both') {
                                times[1] = null;
                            }
                        }
                        else {
                            times[1] = this.timePickerRef.current.getTime();
                        }
                        if (!(this.props.localCheckTimeRange && times[0] && times[1])) return [3 /*break*/, 2];
                        offset = offsetHours(times[0], times[1]);
                        if (!(offset <= 0 || offset < min || offset > max)) return [3 /*break*/, 2];
                        tips = '';
                        // 最短租期提示
                        if (min <= 0) {
                            tips = '租期选择错误';
                        }
                        else {
                            if (min % 24 === 0) {
                                tips = min / 24 + "\u5929\u8D77\u79DF";
                            }
                            else if (min) {
                                tips = min + "\u5C0F\u65F6\u8D77\u79DF";
                            }
                        }
                        // 最长租期提示
                        if (max !== 99999) {
                            // max默认值为99999
                            if (max % 24 === 0) {
                                tips += "\uFF0C\u6700\u957F\u53EF\u79DF" + max / 24 + "\u5929";
                            }
                            else if (max) {
                                tips += "\uFF0C\u6700\u957F\u53EF\u79DF" + max + "\u5C0F\u65F6";
                            }
                        }
                        return [4 /*yield*/, Alert.async({
                                title: '租期限制',
                                desc: React.createElement('p', null, [
                                    tips,
                                    React.createElement('br', { key: 'br' }),
                                    '请重新设置还车时间',
                                ]),
                                btns: [
                                    { name: '取消', type: 'default', value: false },
                                    { name: '设置还车时间', value: true },
                                ],
                            })
                            // 如果按了取消按钮，关闭时间选择器，恢复之前的时间
                        ];
                    case 1:
                        resetTime = _a.sent();
                        // 如果按了取消按钮，关闭时间选择器，恢复之前的时间
                        if (!resetTime) {
                            this.timePickerCancel();
                        }
                        return [2 /*return*/];
                    case 2:
                        this.setState({
                            preChooseRange: __spreadArrays(this.state.chooseRange),
                            preTimePickerTimes: __spreadArrays(times),
                            timePickerTimes: times,
                            timePickerVisible: false,
                        });
                        return [2 /*return*/];
                }
            });
        }); };
        // 时间改变
        _this.onTimeChange = function () { };
        // 确认提交
        _this.onSubmit = function () {
            var times = _this.state.timePickerTimes;
            if (times[0] === null) {
                Toast('请选择取车时间');
                return;
            }
            if (times[1] === null) {
                Toast('请选择还车时间');
                return;
            }
            _this.props.onSubmit(times[0], times[1]);
        };
        // 验证data数据，即key需要是00:00整点时间
        var days = props.data ? Object.keys(props.data).sort() : [];
        days.forEach(function (day) {
            var d = new Date(Number(day));
            if (!_this.isZeroTime(d)) {
                throw new Error('data数据错误');
            }
        });
        // 验证monthRange数据，两个时间必须是00:00的整点时间
        if (!_this.props.monthRange[0] || !_this.isZeroTime(_this.props.monthRange[0])) {
            throw new Error('monthRange数据错误');
        }
        if (!_this.props.monthRange[1] || !_this.isZeroTime(_this.props.monthRange[1])) {
            throw new Error('monthRange数据错误');
        }
        // 初始化state
        var cr1 = props.chooseRange ? props.chooseRange[0] : null;
        var cr2 = props.chooseRange ? props.chooseRange[1] : null;
        if (cr1 && cr2 && cr1.valueOf() >= cr2.valueOf()) {
            throw new Error('chooseRange数据错误');
        }
        if (_this.props.lock && (!cr1 || !cr2)) {
            throw new Error('chooseRange不能为空');
        }
        if (cr1 !== null) {
            cr1 = new Date(cr1.getFullYear(), cr1.getMonth(), cr1.getDate());
        }
        if (cr2 !== null) {
            cr2 = new Date(cr2.getFullYear(), cr2.getMonth(), cr2.getDate());
        }
        var tr1 = props.chooseRange ? props.chooseRange[0] : null;
        var tr2 = props.chooseRange ? props.chooseRange[1] : null;
        _this.state = {
            chooseRange: [cr1, cr2],
            preChooseRange: [cr1, cr2],
            timePickerVisible: false,
            timePickerTimes: [tr1, tr2],
            preTimePickerTimes: [tr1, tr2],
            timePickerTips: {},
            timePickerData: { day: new Date(2000, 1, 1) },
            chooseType: '',
        };
        // 验证参数
        if (props.disabledBefore) {
            if (!_this.isZeroTime(props.disabledBefore)) {
                throw new Error('disabledBefore的时间必须为整点时间');
            }
        }
        return _this;
    }
    Controller.prototype.componentDidMount = function () {
        var cur = document.querySelector('#x-calendar-body .active-first');
        if (!cur) {
            cur = document.querySelector('#x-calendar-body .month-day:not(.empty):not(.disabled)');
        }
        if (cur) {
            setTimeout(function () {
                var top = cur.offsetTop || 0;
                var height = cur.offsetHeight || 0;
                document.querySelector('#x-calendar-body').scrollTop = top - height / 3;
            }, 1);
        }
    };
    // 根据months获取一个月份列表
    Controller.prototype.getMonthList = function () {
        var first = this.props.monthRange[0];
        var last = this.props.monthRange[1];
        var fy = first.getFullYear();
        var fm = first.getMonth();
        var ly = last.getFullYear();
        var lm = last.getMonth();
        var res = [];
        while (fy !== ly || fm !== lm) {
            res.push(new Date(fy, fm));
            if (fm < 11) {
                fm++;
            }
            else {
                fm = 0;
                fy++;
            }
        }
        res.push(new Date(ly, lm));
        return res;
    };
    // 判断一个日期是否在chooseRange范围内
    Controller.prototype.isBtweenChooseRange = function (date) {
        return this.isBtweenRange(date, this.state.chooseRange);
    };
    // 判断一个日期是否在一个范围内
    Controller.prototype.isBtweenRange = function (date, range) {
        if (range[0] === null || range[1] === null) {
            return false;
        }
        if (date < range[0] || date > range[1]) {
            return false;
        }
        return true;
    };
    // 日期点击
    Controller.prototype.onDayClick = function (day, data) {
        return __awaiter(this, void 0, void 0, function () {
            var range, times, type, timePickerTips, res, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        range = [this.state.chooseRange[0], this.state.chooseRange[1]];
                        times = [
                            this.state.timePickerTimes[0],
                            this.state.timePickerTimes[1],
                        ];
                        type = 'rent';
                        if (this.props.lock === 'start') {
                            if (range[0].valueOf() > day.valueOf()) {
                                Toast('取车时间不可修改');
                                return [2 /*return*/];
                            }
                            range[1] = day;
                            times[1] = null;
                            type = 'revert';
                        }
                        else if (this.props.lock === 'end') {
                            if (range[1].valueOf() < day.valueOf()) {
                                Toast('还车时间不可修改');
                                return [2 /*return*/];
                            }
                            range[0] = day;
                            times[0] = null;
                            type = 'rent';
                        }
                        else {
                            if (range[0] && range[1]) {
                                // 处理extend
                                if ((this.props.extend === 'before' || this.props.extend === 'both') &&
                                    range[0].valueOf() > day.valueOf()) {
                                    range[0] = day;
                                    times[0] = null;
                                    type = 'rent';
                                }
                                else if ((this.props.extend === 'after' || this.props.extend === 'both') &&
                                    range[1].valueOf() < day.valueOf()) {
                                    range[1] = day;
                                    times[1] = null;
                                    type = 'revert';
                                }
                                else {
                                    range[0] = day;
                                    range[1] = null;
                                    times[0] = null;
                                    times[1] = null;
                                    type = 'rent';
                                }
                            }
                            else if (range[0] && range[1] === null) {
                                if (range[0] > day) {
                                    range[0] = day;
                                    range[1] = null;
                                    times[0] = null;
                                    times[1] = null;
                                    type = 'rent';
                                }
                                else {
                                    range[1] = day;
                                    times[1] = null;
                                    type = 'revert';
                                }
                            }
                            else {
                                range[0] = day;
                                range[1] = null;
                                times[0] = null;
                                times[1] = null;
                                type = 'rent';
                            }
                        }
                        if ((type === 'rent' && data.rent.length) === 0 ||
                            (type === 'revert' && data.revert.length === 0)) {
                            Toast('该天没有可选的时间');
                            return [2 /*return*/];
                        }
                        if (range[0] && range[1] && !this.checkTimeRangeCanUsed(range, this.state.chooseRange)) {
                            Alert({
                                desc: '您选的期间内有不可租用时间，请重新选择。',
                                btns: [{ name: '好的' }],
                            });
                            return [2 /*return*/];
                        }
                        timePickerTips = {};
                        if (!this.props.onDayClick) return [3 /*break*/, 5];
                        Loading();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.props.onDayClick(day, type)];
                    case 2:
                        res = _a.sent();
                        timePickerTips = res || {};
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4:
                        Loading.hide();
                        _a.label = 5;
                    case 5:
                        this.setState({
                            chooseRange: range,
                            timePickerVisible: true,
                            timePickerTimes: times,
                            timePickerTips: timePickerTips,
                            timePickerData: { day: day, times: type === 'rent' ? data.rent : data.revert },
                            chooseType: type,
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    // 判断是否为整点时间
    Controller.prototype.isZeroTime = function (date) {
        if (!date) {
            return true;
        }
        return date.getHours() + date.getMinutes() + date.getSeconds() + date.getMilliseconds() === 0;
    };
    // 判断时间范围内是否都为可用
    Controller.prototype.checkTimeRangeCanUsed = function (range, ignoreRange) {
        var ignore = __spreadArrays(ignoreRange);
        if (ignore[0] && !ignore[1]) {
            ignore[1] = ignore[0];
        }
        if (!range[0] || !range[1] || range[0] > range[1]) {
            return false;
        }
        if (!this.isZeroTime(range[0]) || !this.isZeroTime(range[1])) {
            return false;
        }
        var data = this.props.data;
        if (!data) {
            return false;
        }
        var current = range[0];
        var target = range[1].valueOf();
        while (current.valueOf() <= target) {
            // 如果在该天已经选中了，则不做数据检查，直接认为该天是可用的
            if (!this.isBtweenRange(current, ignore)) {
                if (!data[current.valueOf()] || data[current.valueOf()].disabled) {
                    return false;
                }
            }
            var d = new Date(current.valueOf());
            current = new Date(d.getFullYear(), d.getMonth(), d.getDate() + 1);
        }
        return true;
    };
    return Controller;
}(React.PureComponent));
;
Controller.defaultProps = {
    maxHours: 99999,
    localCheckTimeRange: true,
};
export default Controller;
