var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import cn from 'classnames';
import * as React from 'react';
import './style.scss';
var TabsItem = function (props) {
    var active = props.active, value = props.value, className = props.className, onClick = props.onClick, children = props.children, otherProps = __rest(props, ["active", "value", "className", "onClick", "children"]);
    var composeClassName = cn('x-tabs__item', {
        'x-tabs--active': !!active,
    }, className);
    var onTabClick = function () {
        onClick(value);
    };
    return (React.createElement("button", __assign({}, otherProps, { className: composeClassName, onClick: onTabClick }), children));
};
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preIndex = -2;
        _this.ref = React.createRef();
        _this.lineRef = React.createRef();
        _this.targetTabItem = null;
        _this.initTimer = null;
        _this.state = {
            currentActiveIndex: -2,
            direction: '',
        };
        _this.animLine = function (anim) {
            if (anim === void 0) { anim = true; }
            _this.targetTabItem = null;
            clearTimeout(_this.initTimer);
            if (_this.preIndex === _this.state.currentActiveIndex) {
                return;
            }
            if (_this.lineRef.current && _this.ref.current) {
                var d = _this.state.direction;
                var index = _this.state.currentActiveIndex;
                _this.targetTabItem = _this.ref.current.querySelectorAll('.x-tabs__item')[index];
                if (!_this.targetTabItem) {
                    return;
                }
                var targetRect = _this.targetTabItem.getBoundingClientRect();
                var parentRect = _this.ref.current.getBoundingClientRect();
                var targetCenter = targetRect.left + targetRect.width / 2 - parentRect.left;
                var process_1 = (targetCenter / parentRect.width) * 100;
                var supT = "transform: translateX(" + process_1 + "%)";
                var subT = "transform: translateX(" + process_1 + "%)";
                var supA = "transition: transform 0.25s " + (d === 'L' ? 'cubic-bezier(0,0,0.5,1)' : d === 'R' ? 'cubic-bezier(0.5,0,1,1)' : 'linear');
                var subA = "transition: transform 0.25s " + (d === 'L' ? 'cubic-bezier(0.5,0,1,1)' : d === 'R' ? 'cubic-bezier(0,0,0.5,1)' : 'linear');
                if (!anim) {
                    supA = '';
                    subA = '';
                }
                _this.lineRef.current.setAttribute('style', 'opacity: 1;');
                _this.lineRef.current.children[1].setAttribute('style', subT + ";" + subA);
                _this.lineRef.current.children[0].setAttribute('style', supT + ";" + supA);
                _this.preIndex = _this.state.currentActiveIndex;
                if (!anim) {
                    _this.onAnimEnd();
                }
            }
        };
        _this.onAnimEnd = function () {
            if (_this.lineRef.current) {
                _this.lineRef.current.removeAttribute('style');
            }
            if (_this.ref.current) {
                var index = _this.state.currentActiveIndex;
                _this.targetTabItem = _this.ref.current.querySelectorAll('.x-tabs__item')[index];
                if (_this.targetTabItem) {
                    _this.targetTabItem.classList.add('x-tabs--active-l');
                }
            }
        };
        return _this;
    }
    Tabs.getDerivedStateFromProps = function (props, state) {
        var children = props.children || [];
        if (!Array.isArray(children)) {
            children = [children];
        }
        for (var i = 0; i < children.length; i++) {
            if (children[i].props && children[i].props.value === props.active) {
                return {
                    currentActiveIndex: i,
                    direction: state.currentActiveIndex > i ? 'L' : state.currentActiveIndex < i ? 'R' : '',
                };
            }
        }
        return {
            currentActiveIndex: -2,
            direction: '',
        };
    };
    Tabs.prototype.componentDidMount = function () {
        if (this.ref.current) {
            var tab = this.ref.current.querySelector('.x-tabs--active');
            if (!tab) {
                return;
            }
            tab.classList.add('x-tabs--active-l');
            this.initTimer = setTimeout(this.animLine, 1000, false);
        }
    };
    Tabs.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, children = _a.children, active = _a.active, onClick = _a.onClick, shrink = _a.shrink, otherProps = __rest(_a, ["className", "children", "active", "onClick", "shrink"]);
        var composeClassName = cn('x-tabs', {
            'x-tabs--shrink': shrink,
        }, className);
        var composeChildren = [];
        if (Array.isArray(children)) {
            composeChildren.push.apply(composeChildren, children);
        }
        else {
            composeChildren.push(children);
        }
        composeChildren = composeChildren.map(function (res, index) {
            var act = _this.props.hasOwnProperty('active') && res.props.value === active;
            return React.cloneElement(res, {
                active: act,
                key: index,
                value: res.props.value,
                onClick: _this.props.onClick,
                children: res.props.children,
            });
        });
        this.animLine(); // 初始化并不执行
        if (shrink) {
            return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
                React.createElement("div", { className: "x-tabs__scroller" },
                    React.createElement("div", { className: "x-tabs__inner", ref: this.ref },
                        composeChildren,
                        React.createElement("div", { className: "x-tabs__line", ref: this.lineRef },
                            React.createElement("sup", { onTransitionEnd: this.onAnimEnd }),
                            React.createElement("sub", null))))));
        }
        return (React.createElement("div", __assign({}, otherProps, { className: composeClassName, ref: this.ref }),
            composeChildren,
            React.createElement("div", { className: "x-tabs__line", ref: this.lineRef },
                React.createElement("sup", { onTransitionEnd: this.onAnimEnd }),
                React.createElement("sub", null))));
    };
    return Tabs;
}(React.PureComponent));
Tabs.Item = TabsItem;
export default Tabs;
